VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Tile tutorial"
   ClientHeight    =   6225
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5895
   LinkTopic       =   "Form1"
   ScaleHeight     =   415
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   393
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox Front 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   4860
      Left            =   480
      ScaleHeight     =   320
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   0
      Top             =   900
      Width           =   4860
   End
   Begin VB.Label lblInfo 
      Caption         =   "Click on the map to set the camera position. Left button uses smoothing, Right button not."
      Height          =   495
      Index           =   0
      Left            =   480
      TabIndex        =   1
      Top             =   300
      Width           =   3375
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Sub Main()
    Me.Show
    
    'Main loop
    While DoEvents
        'Update game
        mCamera.UpdatePosition
        mTiles.Animate
        
        'Update display
        Redraw
    Wend
End Sub

Public Sub Redraw()
    'Draw map
    mMap.Draw
    
    'Update ("flip") display
    Front.Refresh
End Sub

Private Sub Form_Load()
    Dim A As Long
    
    'Initialize modules
    mBitmap.Initialize frmMain
    mMap.Reset
    mTiles.Reset
    mCamera.Reset frmMain.Front
    
    'Create sample tiles
    AddTile 0, False 'Empty "black" tile
    AddTile "1.jpg", True  'Some grass
    AddTile "2.jpg", True  'Stones on grass
    AddTile "3.jpg", False 'A solid pot
    AddAnimTile "4.jpg", 3, 200, False  'A animated flower
    AddAnimTile "5.jpg", 3, 50, False 'Another animated flower
    
    'Now load the bitmaps
    mTiles.LoadResources
    
    'Create map
    CreateMap 80, 80
    
    'Set random tiles
    For A = 0 To Map.w * Map.h
        Select Case Int(20 * Rnd)
            'Pick random tile
            Case Is > 18: Map.Data(A) = 5
            Case Is > 17: Map.Data(A) = 4
            Case Is > 16: Map.Data(A) = 3
            Case Is > 12: Map.Data(A) = 2
            Case Else: Map.Data(A) = 1
        End Select
    Next
    
    'Run engine
    Main
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Release modules
    mTiles.Reset
    mMap.Reset
    mBitmap.Reset
End Sub


Private Sub Front_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Button
        'Set camera position
        Case 1: mCamera.LookAt CLng(X * 3), CLng(Y * 3), True 'Smoothed
        Case 2: mCamera.LookAt CLng(X * 3), CLng(Y * 3), False 'Instant set
    End Select
End Sub

